Merge pull request #39 from frdeso/lava_improve_fuzzing
[lttng-ci.git] / scripts / babeltrace / build.sh
index 4aa0cb62000c3515d2ca6908d6c2252a5ef8d5b3..ba5e0b929fa92a631579a59e4fafbc107e607256 100755 (executable)
@@ -1,6 +1,7 @@
-#!/bin/sh -exu
+#!/bin/bash -exu
 #
 # Copyright (C) 2015 - Jonathan Rajotte-Julien <jonathan.rajotte-julien@efficios.com>
+#               2016 - Michael Jeanson <mjeanson@efficios.com>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-# Create build directory
-rm -rf $WORKSPACE/build
-mkdir -p $WORKSPACE/build
-
+# Version compare functions
+vercomp () {
+    set +u
+    if [[ "$1" == "$2" ]]; then
+        return 0
+    fi
+    local IFS=.
+    local i ver1=($1) ver2=($2)
+    # fill empty fields in ver1 with zeros
+    for ((i=${#ver1[@]}; i<${#ver2[@]}; i++)); do
+        ver1[i]=0
+    done
+    for ((i=0; i<${#ver1[@]}; i++)); do
+        if [[ -z ${ver2[i]} ]]; then
+            # fill empty fields in ver2 with zeros
+            ver2[i]=0
+        fi
+        if ((10#${ver1[i]} > 10#${ver2[i]})); then
+            return 1
+        fi
+        if ((10#${ver1[i]} < 10#${ver2[i]})); then
+            return 2
+        fi
+    done
+    set -u
+    return 0
+}
+
+verlte() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "2" ]
+}
+
+verlt() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "2" ]
+}
+
+vergte() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "0" ] || [ "$res" -eq "1" ]
+}
+
+vergt() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -eq "1" ]
+}
+
+verne() {
+    vercomp "$1" "$2"; local res="$?"
+    [ "$res" -ne "0" ]
+}
+
+# Required parameters
+arch=${arch:-}
+conf=${conf:-}
+build=${build:-}
+
+
+SRCDIR="$WORKSPACE/src/babeltrace"
+TMPDIR="$WORKSPACE/tmp"
 PREFIX="$WORKSPACE/build"
 
-./bootstrap
+# Create build and tmp directories
+rm -rf "$PREFIX" "$TMPDIR"
+mkdir -p "$PREFIX" "$TMPDIR"
 
-CONF_OPTS=""
+export TMPDIR
+export CFLAGS="-g -O2"
 
+# Set platform variables
 case "$arch" in
-solaris10)
-    MAKE=gmake
-    TAR=gtar
-    NPROC=gnproc
-    BISON=bison
-    YACC="$BISON -y"
+sol10-i386)
+    export MAKE=gmake
+    export TAR=gtar
+    export NPROC=gnproc
+    export BISON=bison
+    export YACC="$BISON -y"
+    export PATH="/opt/csw/bin:/usr/ccs/bin:$PATH"
+    export CPPFLAGS="-I/opt/csw/include"
+    export LDFLAGS="-L/opt/csw/lib -R/opt/csw/lib"
+    export PKG_CONFIG_PATH="/opt/csw/lib/pkgconfig"
     ;;
-solaris11)
-    MAKE=gmake
-    TAR=gtar
-    NPROC=nproc
-    BISON="/opt/csw/bin/bison"
-    YACC="$BISON -y"
+sol11-i386)
+    export MAKE=gmake
+    export TAR=gtar
+    export NPROC=nproc
+    export BISON="/opt/csw/bin/bison"
+    export YACC="$BISON -y"
     export PATH="$PATH:/usr/perl5/bin"
+    export CPPFLAGS="-I/opt/csw/include"
+    export LDFLAGS="-L/opt/csw/lib -R/opt/csw/lib"
+    export LD_ALTEXEC=/usr/sfw/bin/gld
+    export LD=/usr/sfw/bin/gld
+    ;;
+macosx)
+    export MAKE=make
+    export TAR=tar
+    export NPROC="getconf _NPROCESSORS_ONLN"
+    export BISON="bison"
+    export YACC="$BISON -y"
+    export PATH="/opt/local/bin:/opt/local/sbin:/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin"
+    export CFLAGS="$CFLAGS -I/opt/local/include"
+    export LDFLAGS="-L/opt/local/lib"
     ;;
 *)
-    MAKE=make
-    TAR=tar
-    NPROC=nproc
-    BISON=bison
-    YACC="$BISON -y"
+    export MAKE=make
+    export TAR=tar
+    export NPROC=nproc
     ;;
 esac
 
+# Enter the source directory
+cd "$SRCDIR"
+
+# Run bootstrap in the source directory prior to configure
+./bootstrap
+
+# Get source version from configure script
+eval "$(grep '^PACKAGE_VERSION=' ./configure)"
+
+# Set configure options for each build configuration
+CONF_OPTS=""
 case "$conf" in
 static)
     echo "Static build"
     CONF_OPTS="--enable-static --disable-shared"
+    if vergte "$PACKAGE_VERSION" "2.0"; then
+        CONF_OPTS="${CONF_OPTS} --enable-built-in-plugins"
+    fi
     ;;
-python-bindings)  
+python-bindings)
     echo "Build with python bindings"
     # We only support bindings built with Python 3
     export PYTHON="python3"
     export PYTHON_CONFIG="/usr/bin/python3-config"
     CONF_OPTS="--enable-python-bindings"
+
+    if vergte "$PACKAGE_VERSION" "2.0"; then
+        CONF_OPTS="${CONF_OPTS} --enable-python-bindings-doc --enable-python-plugins"
+    fi
     ;;
 *)
     echo "Standard build"
@@ -75,57 +171,70 @@ esac
 #
 # Make sure to move to the build_path and configure
 # before continuing
-
-BUILD_PATH=$WORKSPACE
-TEST_PLAN_PATH=$WORKSPACE
-
+BUILD_PATH="$SRCDIR"
 case "$build" in
-       oot)
-               echo "Out of tree build"
-               BUILD_PATH=$WORKSPACE/oot
-               mkdir -p $BUILD_PATH
-               cd $BUILD_PATH
-               MAKE=$MAKE BISON="$BISON" YACC="$YACC" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
-               ;;
-       dist)
-               echo "Distribution out of tree build"
-               BUILD_PATH=`mktemp -d`
-
-               # Initial configure and generate tarball
-               MAKE=$MAKE BISON="$BISON" YACC="$YACC" ./configure
-               $MAKE dist
-
-               mkdir -p $BUILD_PATH
-               cp *.tar.* $BUILD_PATH/
-               cd $BUILD_PATH
-
-               # Ignore level 1 of tar
-               $TAR xvf *.tar.* --strip 1
-
-               MAKE=$MAKE BISON="$BISON" YACC="$YACC" $BUILD_PATH/configure --prefix=$PREFIX $CONF_OPTS
-
-               # Set test plan to dist tar
-               TEST_PLAN_PATH=$BUILD_PATH
-               ;;
-       *)
-               echo "Standard tree build"
-               MAKE=$MAKE BISON="$BISON" YACC="$YACC" $WORKSPACE/configure --prefix=$PREFIX $CONF_OPTS
-               ;;
+    oot)
+        echo "Out of tree build"
+        BUILD_PATH="$WORKSPACE/oot"
+        mkdir -p "$BUILD_PATH"
+        cd "$BUILD_PATH"
+        "$SRCDIR/configure" --prefix="$PREFIX" $CONF_OPTS
+        ;;
+
+    dist)
+        echo "Distribution out of tree build"
+        BUILD_PATH="$(mktemp -d)"
+
+        # Initial configure and generate tarball
+        "$SRCDIR/configure"
+        $MAKE dist
+
+        mkdir -p "$BUILD_PATH"
+        cp ./*.tar.* "$BUILD_PATH/"
+        cd "$BUILD_PATH"
+
+        # Ignore level 1 of tar
+        $TAR xvf ./*.tar.* --strip 1
+
+        "$BUILD_PATH/configure" --prefix="$PREFIX" $CONF_OPTS
+        ;;
+
+    clang)
+        echo "LLVM clang build"
+        export CC=clang
+        clang -v
+       "$SRCDIR/configure" --prefix="$PREFIX" $CONF_OPTS
+        ;;
+    *)
+        echo "Standard in-tree build"
+        "$SRCDIR/configure" --prefix="$PREFIX" $CONF_OPTS
+        ;;
 esac
 
-$MAKE -j `$NPROC`
+# BUILD!
+$MAKE -j "$($NPROC)" V=1
 $MAKE install
-$MAKE check
+
+# Run tests
+$MAKE --keep-going check
+
+# Copy tap logs for the jenkins tap parser
+rsync -a --exclude 'test-suite.log' --include '*/' --include '*.log' --exclude='*' tests/ "$WORKSPACE/tap"
+
+# Clean the build directory
 $MAKE clean
 
-# Cleanup rpath and libtool .la files
-#find $WORKSPACE/build/bin -executable -type f -exec chrpath --delete {} \;
-find $WORKSPACE/build/lib -name "*.so" -exec chrpath --delete {} \;
-find $WORKSPACE/build/lib -name "*.la" -exec rm -f {} \;
+# Cleanup rpath in executables and shared libraries
+find "$PREFIX/bin" -type f -perm -0500 -exec chrpath --delete {} \;
+find "$PREFIX/lib" -name "*.so" -exec chrpath --delete {} \;
+
+# Remove libtool .la files
+find "$PREFIX/lib" -name "*.la" -exec rm -f {} \;
 
-if [ $build = "dist" ]; then
-    cd $WORKSPACE
-    rm -rf $BUILD_PATH
+# Clean temp dir for dist build
+if [ "$build" = "dist" ]; then
+    cd "$SRCDIR"
+    rm -rf "$BUILD_PATH"
 fi
 
 # EOF
This page took 0.02613 seconds and 4 git commands to generate.